#include <stdio.h>
#include <stdlib.h>

int main(int argc,char **argv){
  FILE *src,*dst;
  int srcoff[164],dstoff[164*2];
  char trackmode[164];
  char dsttrackdat[12500],dsttrackmc[1563];
  char srcsect[16384];
  char readbuf[0x5c5];
  int i,track,curbyte,trackpos;
  char mctmp;

  char disktitle[17];
  char wrprotect;
  char disktype;
  char disksize[4];

  char c,h,r,n;
  int sectptrack;
  char sectfm;
  char sectdel;
  char sectstate;
  int sectsize;
  int crc;
  int sectnum;
  int tracksize;

  int tracklen;
  if(argc<3){
    fprintf(stderr,"usase:%s src dst\n",argv[0]);
    exit(-1);
  }
  if((src=fopen(argv[1],"r"))==NULL){
    fprintf(stderr,"File %s can not read.\n",argv[1]);
    exit(1);
  }
  if((dst=fopen(argv[2],"w"))==NULL){
    fprintf(stderr,"File %s can not open.\n",argv[2]);
    exit(2);
  }
  crcinit(16,-1,0x1021);
  fread(readbuf,1,0x2b0,src);
  for(i=0;i<17;i++)disktitle[i]=readbuf[i];
  wrprotect=readbuf[0x1a];
  disktype=readbuf[0x1b];
  for(i=0;i<4;i++)disksize[i]=readbuf[0x1c+i];
  for(i=0;i<164;i++){
    srcoff[i]=(readbuf[0x20+i*4+3])&0x0ff;
    srcoff[i]<<=8;
    srcoff[i]|=(readbuf[0x20+i*4+2])&0x0ff;
    srcoff[i]<<=8;
    srcoff[i]|=(readbuf[0x20+i*4+1])&0x0ff;
    srcoff[i]<<=8;
    srcoff[i]|=(readbuf[0x20+i*4+0])&0x0ff;
  }
  for(i=0;i<164;i++){
    dstoff[i*2]=0;
    dstoff[i*2+1]=0;
  }
  curbyte=0x5c4;
  for(track=0;track<164;track++){
    if(srcoff[track]){
      fseek(src,srcoff[track],SEEK_SET);
      trackpos=0;
      dstoff[track*2]=curbyte;
      fseek(dst,curbyte,SEEK_SET);
      crcclr(-1);
      for(i=0;i<80;i++){
	dsttrackdat[i]=0x4e;
	dsttrackmc[i/8]=0x00;
      }
      curbyte+=80;
      trackpos+=80;

      sectnum=0;
      do{
	for(i=0;i<16;i++){
	  dsttrackdat[trackpos]=0x00;
	  dsttrackmc[trackpos/8]=0x00;
	  trackpos++;
	}
	fread(readbuf,1,0x10,src);
	c=readbuf[0];
	h=readbuf[1];
	r=readbuf[2];
	n=readbuf[3];
	sectptrack=(readbuf[5])&0x0ff;
	sectptrack<<=8;
	sectptrack|=(readbuf[4])&0x0ff;
	sectfm=readbuf[6];
	sectdel=readbuf[7];
	sectstate=readbuf[8];
	sectsize=(readbuf[0xf])&0x0ff;
	sectsize<<=8;
	sectsize|=(readbuf[0xe])&0x0ff;
	
	crcclr(-1);
	dsttrackdat[trackpos++]=0xa1;
	crccalc(0xa1);
	dsttrackdat[trackpos++]=0xa1;
	crccalc(0xa1);
	dsttrackdat[trackpos++]=0xa1;
	crccalc(0xa1);
	dsttrackdat[trackpos++]=0xfe;
	crccalc(0xfe);
	dsttrackdat[trackpos++]=c;
	crccalc(c);
	dsttrackdat[trackpos++]=h;
	crccalc(h);
	dsttrackdat[trackpos++]=r;
	crccalc(r);
	dsttrackmc[trackpos/8]=0xe0;
	dsttrackdat[trackpos++]=n;
	crccalc(n);
	crc=crcget();
	if(sectstate==0xa0)crc=~crc;
	dsttrackdat[trackpos++]=(crc>>8)&0x0ff;;
	dsttrackdat[trackpos++]=crc&0x0ff;
	curbyte+=26;
	crcclr(-1);
	for(i=0;i<26;i++){
	  dsttrackdat[trackpos]=0x4e;
	  dsttrackmc[trackpos/8]=0x00;
	  trackpos++;
	  curbyte++;
	}
	for(i=0;i<12;i++){
	  dsttrackdat[trackpos]=0x00;
	  dsttrackmc[trackpos/8]=0x00;
	  trackpos++;
	  curbyte++;
	}
	dsttrackdat[trackpos++]=0xa1;
	crccalc(0xa1);
	dsttrackdat[trackpos++]=0xa1;
	crccalc(0xa1);
	dsttrackdat[trackpos++]=0xa1;
	crccalc(0xa1);
	if(sectdel){
	  dsttrackdat[trackpos++]=0xf8;
	  crccalc(0xf8);
	}else{
	  dsttrackdat[trackpos++]=0xfb;
	  crccalc(0xfb);
	}
	dsttrackmc[trackpos/8]=0xe0;
	curbyte+=4;
	fread(&dsttrackdat[trackpos],1,sectsize,src);
	for(i=0;i<sectsize;i++)crccalc(dsttrackdat[trackpos+i]);
	for(i=4;i<sectsize;i++)dsttrackmc[(trackpos+i)/8]=0x00;
	trackpos+=sectsize;
	curbyte+=sectsize;
	crc=crcget();
	if(sectstate==0xb0)crc=~crc;
	dsttrackdat[trackpos++]=(crc>>8)&0x0ff;
	dsttrackdat[trackpos]=(crc&0x0ff);
	dsttrackmc[trackpos/8]=0x00;
	trackpos++;
	curbyte+=2;
	for(i=0;i<32;i++){
	  dsttrackdat[trackpos]=0x4e;
	  dsttrackmc[trackpos/8]=0x00;
	  trackpos++;
	  curbyte++;
	}
	for(;(trackpos%8)!=0;trackpos++){
	  dsttrackdat[trackpos]=0x4e;
	  dsttrackmc[trackpos/8]=0x00;
	  curbyte++;
	}
	sectnum++;
      }while(sectnum<sectptrack);
      switch(disktype){
      case 0x00:
	tracksize=3128;
	break;
      case 0x10:
	tracksize=3128;
	break;
      case 0x20:
	tracksize=6256;
	break;
      default:
	tracksize=0;
      }
      if(!sectfm)tracksize*=2;
      for(;trackpos<tracksize;trackpos++){
	dsttrackdat[trackpos]=0x4e;
	dsttrackmc[trackpos/8]=0x00;
	curbyte++;
      }
      fwrite(dsttrackdat,1,trackpos,dst);
      dstoff[track*2+1]=curbyte;
      fseek(dst,curbyte,SEEK_SET);
      fwrite(dsttrackmc,1,(trackpos/8),dst);
      curbyte+=(trackpos/8);
      trackmode[track]=sectfm;
    }
  }
  fseek(dst,0,SEEK_SET);
  for(i=0;i<17;i++)readbuf[i]=disktitle[i];
  for(i=0;i<9;i++)readbuf[17+i]=0x00;
  readbuf[0x1a]=wrprotect;
  readbuf[0x1b]=disktype;
  readbuf[0x1c]=(curbyte&0x000000ff);
  readbuf[0x1d]=(curbyte&0x0000ff00)>>8;
  readbuf[0x1e]=(curbyte&0x00ff0000)>>16;
  readbuf[0x1f]=(curbyte&0xff000000)>>24;
  for(i=0;i<328;i++){
    readbuf[0x20+i*4+0]=(dstoff[i]&0x000000ff);
    readbuf[0x20+i*4+1]=(dstoff[i]&0x0000ff00)>>8;
    readbuf[0x20+i*4+2]=(dstoff[i]&0x00ff0000)>>16;
    readbuf[0x20+i*4+3]=(dstoff[i]&0xff000000)>>24;
  }
  fwrite(readbuf,1,0x520,dst);
  fwrite(trackmode,1,164,dst);
  return 0;
}


      
  
